#!/usr/bin/env Rscript

# Wrapper for the coverageReporter script. It lives as an R shell script in
# order to be seamlessly integrated to the general variant calling pipeline
# which uses only system interactions.
# Author: Panagiotis Moulos (moulos@fleming.gr)

suppressPackageStartupMessages(library("optparse"))
#!/usr/bin/env Rscript

# Wrapper for the GATK coverage correction script. It lives as an R shell
# script in order to be seamlessly integrated to the general variant calling
# pipeline which uses only system interactions.
#
# Author: Panagiotis Moulos (moulos@fleming.gr)

suppressPackageStartupMessages(library("optparse"))
source("/usr/local/src/scripts/coverageReporter.R")

option_list <- list(
	make_option(
		opt_str=c("-v","--vcf"),
		action="store",
		default=NULL,
		help=paste0(
			"A VCF file, usually the result of GATK pipeline for\n",
			"		calling somatic mutations (Mutect, Mutect2)."
		)
	),
	make_option(
		opt_str=c("-b","--bam"),
		action="store",
		default=NULL,
		help=paste0(
			"The BAM file used to call mutations. Tumor only for now.\n",
			"		Must be sorted/indexed. If not, it's done on the fly."
		)
	),
	make_option(
		opt_str=c("-g","--org"),
		action="store",
		default="hg19",
		help="Supported organisms. One of 'hg19' (default) or 'hg38'."
	),
	make_option(
		opt_str=c("-l","--fraglen"),
		action="store",
		default=300,
		help=paste0(
			"The average read length yielded by the instrument used\n",
			"		for sequencing. Default is 300 (Illumina MiSeq).\n",
			"		Together with the fracFac argument, it is used to define\n",
			"		a region to mask the BAM file for speed and memory\n",
			"		usage. Set to 0 in order toimport the whole BAM file."
		)
	),
	make_option(
		opt_str=c("-f","--fragfac"),
		action="store",
		default=2,
		help=paste0(
			"A coefficient to multiply fragLen with. The final number is\n",
			"		used to extend the variant locations read from the VCF\n",
			"		file to define a region to mask the BAM file for speed.\n",
			"		It defaults to 2. Set to a large number (e.g. 100 to \n",
			"		ensure importing the whole BAM file."
		)
	),
	make_option(
		opt_str=c("-c","--dpcalc"),
		action="store",
		default="pileup",
		help=paste0(
			"How to calculate depth coverage. It can be 'pileup' to use the \n",
			"		allele coverage data collected by this script or \n",
			"		'coverage' to use the native coverage Bioconductor \n",
			"		 method that operates on the *GAlignments* classes and\n",
			"		 is aware of CIGAR strings. Defaults to 'pileup' as\n",
			"		 experience showed that native coverage does not always\n",
			"		 yield logical outcomes or slightly misplaced."
		)
	),
	make_option(
		opt_str=c("-o","--output"),
		action="store",
		default=NULL,
		help=paste0(
			"An output filename (and path). If NULL (default) it is\n",
			"		autogenerated by adding .dpcor to the file name\n",
			"		(maintaining whatever extension)."
		)
	),
	make_option(
		opt_str=c("-i","--indexoutput"),
		action="store_true",
		default=TRUE,
		help="Compress and index the output VCF file?"
	),
	make_option(
		opt_str=c("-p","--pairedopts_ispaired"),
		action="store",
		default=NULL,
		help=paste0(
			"If switched on, assumes that the input BAM file is a product\n",
			"		of paired-end alignment. Otherwise, a test to check\n",
			"		whether there is single or paired-end sequencing is\n",
			"		performed if the -a option is switched on."
		)
	),
	make_option(
		opt_str=c("-a","--pairedopts_aspaired"),
		action="store_true",
		default=FALSE,
		help=paste0(
			"Should the input BAM file be read as a paired-end sequencing\n",
			"		BAM file? If -a is switched on, the GenomicAlignments\n",
			"		pairing algorithm will run (resulting in slower\n",
			"		execution). This option should not be set for simple\n",
			"		coverage calculations."
		)
	),
	make_option(
		opt_str=c("-m","--pairedopts_iflist"),
		action="store",
		default="list",
		help=paste0(
			"How should be the paired alignments read if -a is on.\n",
			"		Can be 'list' (default) to use the readGAlignmentsList\n",
			"		function or 'pairs' to use the reagGAlignmentsPairs\n",
			"		function. Please refer to the official Bioconductor\n ",
			"		documentation for the differences."
		)
	),
	make_option(
		opt_str=c("-e","--replaceoriginal"),
		action="store_true",
		default=FALSE,
		help=paste0(
			"Replace original DP, AD values or add new fields to the INFO\n",
			"		and FORMAT columns (TDP, TAD). Defaults to FALSE\n",
			"		 (create new)."
		)
	),
	make_option(
		opt_str=c("-t","--corefraction"),
		action="store",
		default=0,
		help=paste0(
			"A number between 0 and 1 which denotes the fraction of\n",
			"		cores to be used for parallel calculations. If 0, a\n",
			"		single core is used (default in Windows)."
		)
	)
)

opt <- parse_args(OptionParser(option_list=option_list))

# TODO: more checks
if (!(opt$org %in% c("hg19","hg38")))
	stop("The organism must be one of \"hg19\",\"hg38\"!")
if (!is.numeric(opt$fraglen) || opt$fraglen<0)
	stop("Fragment length must be a positive integer!")
if (!is.numeric(opt$fragfac) || opt$fragfac<0)
	stop("Fragment fraction multiplier must be a positive numeric!")
if (!(opt$dpcalc %in% c("pileup","coverage")))
	stop("Depth calculation method must be one of \"pileup\",\"coverage\"!")
if (opt$corefraction<0 || opt$corefraction>1)
	stop("The fraction of cores to use must be between 0 and 1")

reportCoverage(vcf=opt$vcf,bam=opt$bam,org=opt$org,fragLen=opt$fraglen,
	fragFac=opt$fragfac,dpCalc=opt$dpcalc,output=opt$output,
	indexOutput=opt$indexoutput,pairedOpts=list(isPaired=opt$pairedopts_ispaired,
	asPaired=opt$pairedopts_aspaired,ifList=opt$pairedopts_iflist),
	replaceOrig=opt$replaceoriginal,rc=opt$corefraction)
